//---------------------------------------------------------------------------

// Copyleft Fabrice Sincre ; mai 2011
// IDE : C++ Borland Builder 5.0


#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

////////////////////////////////////////////
// On utilise la librairie C de MySQL //////
#define __WIN__
#include "mysql.h"
////////////////////////////////////////////

MYSQL *mySQL;
MYSQL_ROW myROW;
MYSQL_RES *myRES;
AnsiString aStr;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_closeClick(TObject *Sender)
{

// close

ListBox1->Items-> Add("Close");
ListBox1->Items->Add("----------");
ListBox1->Items->Add("");

Button_connect -> Enabled = true;
Button_requete -> Enabled = false;
Button_close -> Enabled = false;

mysql_close(mySQL);

}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button_connectClick(TObject *Sender)
{

// bouton connexion

// initialisation
mySQL = mysql_init(NULL);

// conversion AnsiString -> char
char *hostname  = new char[ Edit_host->Text.Length() + 1 ];
strcpy( hostname, Edit_host->Text.c_str() );

char *user  = new char[ Edit_user->Text.Length() + 1 ];
strcpy( user, Edit_user->Text.c_str() );

char *password  = new char[ Edit_password ->Text.Length() + 1 ];
strcpy( password, Edit_password->Text.c_str() );

char *database  = new char[ Edit_database->Text.Length() + 1 ];
strcpy( database, Edit_database->Text.c_str() );


if (!mysql_real_connect(mySQL,hostname,user,password,database,0,NULL,0))
{
        // la connexion a chou
        ListBox1->Items-> Clear();
        const char *message_erreur;
        message_erreur = mysql_error(mySQL);
        ShowMessage(message_erreur);

        Button_connect -> Enabled = true;
        Button_requete -> Enabled = false;
        Button_close -> Enabled = false;
}
else
{
        // la connexion a russi
        Button_connect -> Enabled = false;
        Button_requete -> Enabled = true;
        Button_close -> Enabled = true;

        ListBox1->Items-> Clear();
        ListBox1->Items-> Add("Server is connected");
        ListBox1->Items->Add("----------");
        ListBox1->Items->Add("");


}
}


//---------------------------------------------------------------------------
void __fastcall TForm1::Button_requeteClick(TObject *Sender)
{
// requte

// conversion AnsiString -> char
char *requete  = new char[ Edit_requete->Text.Length() + 1 ];
strcpy( requete, Edit_requete->Text.c_str() );


if (!mysql_ping(mySQL))
{
        
        if (!mysql_query(mySQL, requete))
        {


                ListBox1->Items->Add(requete);
                ListBox1->Items->Add("----------");
                ListBox1->Items->Add("");

                myRES = mysql_store_result(mySQL);
                if (myRES)
                {
                        for(unsigned int i = 0; i < myRES->row_count; i++)
                        {
                                myROW = mysql_fetch_row(myRES);
                                for(unsigned int j = 0; j < mysql_num_fields(myRES); j++)
                                {
                                        aStr = myROW[j];
                                        ListBox1->Items->Add(aStr);
                                }
                        }
                        mysql_free_result(myRES);
                }
                ListBox1->Items->Add("");
        }
        else
        {
                // erreur de requte
                const char *message_erreur;
                message_erreur = mysql_error(mySQL);
                ShowMessage(message_erreur);

        }

}

else
{
        // erreur ping : dlai d'attente dpass

        ListBox1->Items-> Add("Time out : server disconnected");
        ListBox1->Items->Add("----------");
        ListBox1->Items->Add("");

        // reconnexion   /////////////////

        // conversion AnsiString -> char
        char *hostname  = new char[ Edit_host->Text.Length() + 1 ];
        strcpy( hostname, Edit_host->Text.c_str() );

        char *user  = new char[ Edit_user->Text.Length() + 1 ];
        strcpy( user, Edit_user->Text.c_str() );

        char *password  = new char[ Edit_password ->Text.Length() + 1 ];
        strcpy( password, Edit_password->Text.c_str() );

        char *database  = new char[ Edit_database->Text.Length() + 1 ];
        strcpy( database, Edit_database->Text.c_str() );


        if (!mysql_real_connect(mySQL,hostname,user,password,database,0,NULL,0))
        {
                //la connexion a chou
                ListBox1->Items-> Clear();
                const char *message_erreur;
                message_erreur = mysql_error(mySQL);
                ShowMessage(message_erreur);

                Button_connect -> Enabled = true;
                Button_requete -> Enabled = false;
                Button_close -> Enabled = false;


        }
        else
        {
        
                Button_connect -> Enabled = false;
                Button_requete -> Enabled = true;
                Button_close -> Enabled = true;


                ListBox1->Items-> Add("Server is reconnected");
                ListBox1->Items->Add("----------");
                ListBox1->Items->Add("");

                if (!mysql_query(mySQL, requete))
                {

                        ListBox1->Items->Add(requete);
                        ListBox1->Items->Add("----------");
                        ListBox1->Items->Add("");


                        myRES = mysql_store_result(mySQL);
                        if (myRES)
                        {
                                for(unsigned int i = 0; i < myRES->row_count; i++)
                                {
                                        myROW = mysql_fetch_row(myRES);
                                        for(unsigned int j = 0; j < mysql_num_fields(myRES); j++)
                                        {
                                                aStr = myROW[j];
                                                ListBox1->Items->Add(aStr);
                                        }
                                }
                                mysql_free_result(myRES);
                        }
                        ListBox1->Items->Add("");
                }
        }

}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_clearClick(TObject *Sender)
{
ListBox1->Items-> Clear();
}
//---------------------------------------------------------------------------

